=== debian/changelog ===
wxformbuilder (4.2.1-1) unstable; urgency=low

  * Initial release (Closes: #390135)

 -- Steve Meliza <swm@swm1.com>  Tue, 27 Aug 2024 17:00:44 -0700
