=== debian/control ===
Source: wxformbuilder
Section: devel
Priority: optional
Maintainer: Steve Meliza <swm@swm1.com>
Build-Depends: debhelper-compat (= 13),
               cmake (>= 3.21),
               libwxgtk3.2-dev,
               libwxgtk-media3.2-dev,
               libboost-dev
Standards-Version: 4.7.0
Homepage: http://wxformbuilder.org/
Vcs-Browser: https://salsa.debian.org/melizas-guest/wxFormBuilder
Vcs-Git: https://salsa.debian.org/melizas-guest/wxFormBuilder.git
Rules-Requires-Root: no

Package: wxformbuilder
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: wxwidgets,
          codeblocks
Description: GUI designer for the wxWidgets toolkit
 wxFormBuilder is a GUI builder for the wxWidgets framework.
 .
 Code generation is supported for C++, Python, Lua and PHP.
 Additionally, the import and export of XRC code is possible.
 To support additional widgets, custom plugins can be used.
