=== debian/watch ===
version=4
opts="searchmode=plain,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//,\
filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%" \
https://api.github.com/repos/wxFormBuilder/wxFormBuilder/releases?per_page=50 \
https://github.com/[^/]+/[^/]+/releases/download/v?[\d\.]+/wxFormBuilder-@ANY_VERSION@-source-full@ARCHIVE_EXT@
